#ifndef _irbrowser_h
#define _irbrowser_h
/****************************************************************************/
/*                                                                          */
/*  Copyrighted by PostModern Computing Technologies, Inc                   */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, 94043, USA           */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

#include <stdlib.h>
#include "irclnt.hh"
#include "dsordclt.h"


class IRBrowser
{
private:
  static DSOrderedCltn _objectHistory;
  static char command_buffer[100];

  static int  arg;

// ----------------------------------
// Various varieties of return types
// ----------------------------------

// For contents(), etc.
  static CORBA_IR::Container::IDLSequence(CORBA_IR__Contained)* contentsResult;
  static CORBA_IR::Container::IDLSequence(CORBA_IR__Contained)* newContentsResult;

// For describe_contents()
  static CORBA_IR::Container::IDLSequence(CORBA_IR__Container__Description)* 
    descriptionResult;

public:  
  static CORBA_IR::Repository* repository;

public:

// ------------------------------
// User-driven input functions
// ------------------------------
public:  
  static void printHelp();
  static void printPrompt();
  static void getInput();
  static void lookup_id();
  static void within();
  static void describe();
  static void contents();
  static void lookup_name();
  static void describe_contents();
  static void describe_interface();
  static void base_interfaces();
  static void name();
  static void id();
  static void defined_in();
  static void type();
  static void value();
  static void result();
  static void mode();
  static void quit();
  static void show();
  static void info();
  static void help();
  static void dispatch();

// The following functions are helpers (not directly called by users)

  static void contentsHelper();
  static void prettyPrintContentsResult();

  static void describeContentsHelper();
  static void prettyPrintDescriptionResult();

  static void lookupNameHelper();

  static const char * interfaceType(CORBA_IR::Contained* contained);

  static void releaseContentsResult();
  static void update();
};  

#endif
