#ifndef _context_h
#define _context_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

// NON-Reentrant version of context
class Context: public DSResource
{
	DECLARE_NCOBJECT_CLASS(Context);
    private:
	String			_contextName;
	PropertyList		_properties;
	DSDictionary		_children;
	Context			*_parent;
    protected:
	void	parent(Context *ctx);
	Context *parent() { return _parent; }

	void	_values(const char *prop_name, CORBA::ULong len,
				PropertyList *list,
				Boolean restrict_scope) const;
	const Context	*_find_context(const char *ctx_name) const;
    public:
	Context() { _parent = (Context *)NULL; }
	Context(const Context& );
	Context(const Context&, const char *prop_name1, ...);
	Context& operator=(const Context& );
	virtual ~Context() {}

	virtual void copyFrom(NCistream& strm);
	void get(NCistream& strm) { copyFrom(strm); }
	void put(NCostream& strm) const { write(strm); }
	

	virtual void value(const char *prop_name, const char *prop_value);
	virtual void value(const Property& value);
	virtual void value(Property *value);

	virtual void values(const PropertyList& values);
	virtual void values(PropertyList *values);

	virtual PropertyList *values(const char *start_scope,
				const char *prop_name,
				Boolean restrict_scope = 0) const;
	
	virtual void delete_values(const char *prop_name);
	virtual Context *create_child(const char *ctx_name);

	const char *name() const { return (const char *)_contextName; }
};

#endif


