// "@(#)Module Name: dsassoc.h Version:2.1 Date: 94/06/19"
#ifndef _dsassoc_h
#define _dsassoc_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <dsresour.h>

// ------------------------------------------------------------------------
// Implemenation of an Association. Associations are usually used in
// Dictionaries. The Association stores key and value pairs.
// ------------------------------------------------------------------------
class DSAssoc: public DSResource
{
	DECLARE_NCOBJECT_CLASS(DSAssoc);
    private:
	DSResource	*_key;
	DSResource	*_value;

	DSAssoc();
    public:
	DSAssoc(DSResource& key, DSResource& value);
	virtual ~DSAssoc() { 
		DSResource::unref(_key); 
		DSResource::unref(_value); 
	}

	virtual NCbool isEqual(const NCObject& p) const;
	DSResource *key() const { return _key; }
	DSResource *value() const { return _value; }

	void key(DSResource& key) {
		DSResource::unref(_key);
		_key = &key; 
		DSResource::ref(_key);
	}
	void value(DSResource& value) { 
		DSResource::unref(_value);
		_value = &value; 
		DSResource::ref(_value);
	}
};
	

#endif
