#ifndef _env_h_
#define _env_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

#include "except.h"
class Environment: public DSResource
{
	DECLARE_NCOBJECT_CLASS(Environment);
    public:
	Environment() { _exception = (Exception *)NULL; }
	virtual ~Environment() { DSResource::unref(_exception); } 
	virtual void copyFrom(NCistream& strm);
	void get(NCistream& strm) { copyFrom(strm); }
	void put(NCostream& strm) const { write(strm); }

	Boolean check_exception() const { 
		return _exception != (Exception *)NULL; 
	}
	const Exception *exception_value() const { return _exception; }
	Exception *exception_value() { return _exception; }
	void  exception_value(Exception *exp) {
		DSResource::unref(_exception);
		_exception = exp;
		DSResource::ref(_exception);
	}
	void  clear_exception() { 
		DSResource::unref(_exception);
		_exception = (Exception *)NULL;
	}
    private:
	Exception			*_exception;
};

#endif
   
