#ifndef _orb_h_
#define _orb_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

class ORB
{
    public:
	enum _ORBType {
		_ORB_UNKNOWN = 0,
		_ORB_POSTMODERN =1,
		_ORB_SUN =2,
		_ORB_HP =3
	};
		
    public:

	// CORBA Compliant methods
	virtual CORBA::String	*object_to_string(const CORBA::Object& obj) 
				const;
	virtual CORBA::Object	*string_to_object(const char *str) const;
	virtual CORBA::Object   *string_to_object(const CORBA::String& str) 
					const {
		return string_to_object((const char *)str);
	}
	static CORBA::Context&  default_context(); 

	// Methods used by Stubs generated by ORBELINE compiler
	static ORB *instance(_ORBType type = _ORB_POSTMODERN);
	_ORBType type() const { return _orb_type; }

	virtual CORBA::ULong	bind(const CORBA::Principal& principal,
					CORBA::Object *obj,
					const char *interface_name,
					CORBA::Environment& env,
					const char *object_name = 
						(const char *)NULL,
					const char *host_name = 
						(const char *)NULL) =0;

	virtual CORBA::ULong	clone(ORB *orb, CORBA::ULong client_id,
					CORBA::Object *obj,
					const CORBA::Principal& princ,
					const char *interface_name,
					CORBA::Environment& env,
					const char *object_name= 
						(const char *)NULL) =0;

	virtual void		unbind(CORBA::ULong client_id, 
					CORBA::Environment& env) =0;

	virtual void		close(CORBA::ULong client_id, 
					CORBA::Environment& env) =0;

	virtual MarshalStream 	*create_oneway_request(CORBA::ULong client_id,
					const char *interface_name,
					CORBA::ULong method_id,
					unsigned int msg_num,
					CORBA::Environment& env) =0;

	virtual MarshalStream	*create_invoke_request(CORBA::ULong client_id,
					const char *interface_name,
					CORBA::ULong method_id,
					unsigned int msg_num,
					CORBA::Environment& env) =0;

	virtual void		send_oneway(
					CORBA::ULong client_id,
					unsigned int msg_num,
					CORBA::Environment& env) =0;

	virtual MarshalStream	*invoke(CORBA::ULong client_id,
					unsigned int msg_num,
					CORBA::Environment& env) =0;

	virtual	void		trigger(CORBA::Object *obj, 
					const char *interface_name,
					CORBA::Environment& env,
					const char *object_name = 
						(const char *)NULL,
					const char *host_name = 
						(const char *)NULL) =0;
	static void	clean_up();
    protected:
	_ORBType	_orb_type;
	static Context	*_context;

	ORB(_ORBType type) { _orb_type = type; }
	virtual ~ORB() {}
};
	
#endif
