#ifndef _stexcep_h
#define _stexcep_h	
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

#define declareStExcep(classname)					\
class classname : public SystemException				\
{									\
	DECLARE_NCOBJECT_CLASS(classname);				\
    public:								\
	classname(ULong minor, completion_status status) :		\
		SystemException(minor, status) {}			\
	classname() {}							\
									\
	static classname *_cast(Exception *exc) {			\
                if ( !exc) return (classname *)NULL;                    \
                else if (!exc->canCast(class_info) ) return (classname *)NULL;\
                else return (classname *)exc;                           \
        }                                                               \
	static const classname *_cast(const Exception *exc) {		\
                if ( !exc) return (classname *)NULL;                    \
                else if (!exc->canCast(class_info) ) return (classname *)NULL;\
                else return (classname *)exc;                           \
	}								\
}


#define implementStExcep(classname)					\
DEFINE_NCOBJECT_CLASS1(CORBA::StExcep::classname, CORBA::SystemException); \
									\
CORBA::StExcep::classname::classname(NCistream& strm) : 		\
	CORBA::SystemException(strm)					\
{									\
}									\
									\
void CORBA::StExcep::classname::write(NCostream& strm) const		\
{									\
	CORBA::SystemException::write(strm);				\
}									\
									\
void CORBA::StExcep::classname::prettyPrint(NCostream& strm) const	\
{									\
	CORBA::SystemException::prettyPrint(strm);			\
}									\
									\
int CORBA::StExcep::classname::compare(const NCObject& p) const		\
{									\
	return CORBA::SystemException::compare(p);			\
}									\
									\
unsigned CORBA::StExcep::classname::hash() const			\
{									\
	return CORBA::SystemException::hash();				\
} 



// Standard exception classes
class StExcep
{
    public:
	enum exception_type {
		NO_EXCEPTION =0,
		USER_EXCEPTION=1,
		SYSTEM_EXCEPTION=2
	};
	declareStExcep(UNKNOWN);
	declareStExcep(BAD_PARAM);
	declareStExcep(NO_MEMORY);
	declareStExcep(IMP_LIMIT);
	declareStExcep(COMM_FAILURE);
	declareStExcep(INV_OBJREF);
	declareStExcep(NO_PERMISSION);
	declareStExcep(INTERNAL);
	declareStExcep(MARSHAL);
	declareStExcep(INITIALIZE);
	declareStExcep(NO_IMPLEMENT);
	declareStExcep(BAD_TYPECODE);
	declareStExcep(BAD_OPERATION);
	declareStExcep(NO_RESOURCES);
	declareStExcep(NO_RESPONSE);
	declareStExcep(PERSIST_STORE);
	declareStExcep(BAD_INV_ORDER);
	declareStExcep(TRANSIENT);
	declareStExcep(FREE_MEM);
	declareStExcep(INV_IDENT);
	declareStExcep(INV_FLAG);
	declareStExcep(INTF_REPOS);
	declareStExcep(CONTEXT);
	declareStExcep(OBJ_ADAPTER);
	declareStExcep(DATA_CONVERSION);
};

#endif
